;		*****  I 8 0 C 2 0 5 1	P R O C	E S S O	R  *****

;-----------------------------------------------------------------------------
;				Definitions
;-----------------------------------------------------------------------------
YES		equ	    1
NO		equ	    0
D80550		equ	  550
I80C52		equ	   52
I80552		equ	  552
A89C2051	equ	 2051

LoN	equ	00FH		;mask for low  nible
HiN	equ	0F0H		;mask for high nible
SPACE	equ	00AH		;Space (on display)

Bank_0	equ	000H		;Constant for Bank 0 selection
Bank_1	equ	008H		;Constant for Bank 1 selection
Bank_2	equ	010H		;Constant for Bank 2 selection
Bank_3	equ	018H		;Constant for Bank 3 selection

Mem_r0	equ	  0H		;Offset	memory address of register r0 in bank 
Mem_r1	equ	  1H		;Offset	memory address of register r1 in bank
Mem_r2	equ	  2H		;Offset	memory address of register r2 in bank
Mem_r3	equ	  3H		;Offset	memory address of register r3 in bank
Mem_r4	equ	  4H		;Offset	memory address of register r4 in bank
Mem_r5	equ	  5H		;Offset	memory address of register r5 in bank
Mem_r6	equ	  6H		;Offset	memory address of register r6 in bank
Mem_r7	equ	  7H		;Offset	memory address of register r7 in bank

Bank_0_r0	equ	Bank_0 or Mem_r0
Bank_0_r1	equ	Bank_0 or Mem_r1
Bank_0_r2	equ	Bank_0 or Mem_r2
Bank_0_r3	equ	Bank_0 or Mem_r3
Bank_0_r4	equ	Bank_0 or Mem_r4
Bank_0_r5	equ	Bank_0 or Mem_r5
Bank_0_r6	equ	Bank_0 or Mem_r6
Bank_0_r7	equ	Bank_0 or Mem_r7

Bank_1_r0	equ	Bank_1 or Mem_r0
Bank_1_r1	equ	Bank_1 or Mem_r1
Bank_1_r2	equ	Bank_1 or Mem_r2
Bank_1_r3	equ	Bank_1 or Mem_r3
Bank_1_r4	equ	Bank_1 or Mem_r4
Bank_1_r5	equ	Bank_1 or Mem_r5
Bank_1_r6	equ	Bank_1 or Mem_r6
Bank_1_r7	equ	Bank_1 or Mem_r7

Bank_2_r0	equ	Bank_2 or Mem_r0
Bank_2_r1	equ	Bank_2 or Mem_r1
Bank_2_r2	equ	Bank_2 or Mem_r2
Bank_2_r3	equ	Bank_2 or Mem_r3
Bank_2_r4	equ	Bank_2 or Mem_r4
Bank_2_r5	equ	Bank_2 or Mem_r5
Bank_2_r6	equ	Bank_2 or Mem_r6
Bank_2_r7	equ	Bank_2 or Mem_r7

Bank_3_r0	equ	Bank_3 or Mem_r0
Bank_3_r1	equ	Bank_3 or Mem_r1
Bank_3_r2	equ	Bank_3 or Mem_r2
Bank_3_r3	equ	Bank_3 or Mem_r3
Bank_3_r4	equ	Bank_3 or Mem_r4
Bank_3_r5	equ	Bank_3 or Mem_r5
Bank_3_r6	equ	Bank_3 or Mem_r6
Bank_3_r7	equ	Bank_3 or Mem_r7

;-----------------------------------------------------------------------------
;			       Configuration
;-----------------------------------------------------------------------------
CECKO		EQU	   NO		;Is Main program in "C"	language ?

RS485		equ	  YES		;TYPE RS485 x RS232
DEBUG		equ	  YES		;Debug?	 no->N - Normal
					;Debug?	yes->Y - Debug
Processor	equ  A89C2051
				

;*************** HARDWARE PARAMETERs *****************************************

FREQ	EQU	11059		;Crystal frequency [kHz]

CYCLE	EQU	(((FREQ+40)/80+60000)/((FREQ+20)/40))*5			;[ns]

SAMPLE	EQU	50		;Sampling [ms]

c_Timer0	equ    08800h	;Interrupt every 33.33333ms
c_TicksCounter	equ	  03	;Number	Timer0 interrupts per 0.1sec

c_FlipFlop	equ	 00FFh
c_maxDALLAS	equ	   62

BAUD19	equ	0fdh		;19200Bd !!!but	with double input  freq.!!!
BAUD96	equ	0fdh		; 9600Bd
BAUD48	equ	0fah		; 4800Bd
BAUD24	equ	0f4h		; 2400Bd
BAUD12	equ	0e8h		; 1200Bd
BAUD60	equ	0d0h		;  600Bd
BAUD30	equ	0a0h		;  300Bd
BAUD15	equ	040h		;  150Bd

;**************	SPECIAL	REGISTERs ********************************************

IDLE	DATA	01H		;Entry idle mode

;**************	SPECIAL	REGISTERs SETUP	**************************************

iPSW	EQU	00000000B	;Program Status	Word
;		
;		 P	: Parity flag
;		*F1	: Flag 1
;		 OV	: OVerflow
;		 RS1,0: 00=00..07H, 01=08..0F, 10=10..17, 11=18..1F
;		 F0	: Flag 0
;		 AC	: Auxiliary Carry
;		 CY	: CarrY	flag

iPCON	EQU	00000000B	;Power Control
;		xxx
;		    IDL	: 1=Idle
;		    PD	: 1=Power Down
;		    GF0	: user bit
;		    GF1	: user bit
;		 SMOD	: 0=fx/2, 1=fx/1 for timers in mode 1,2,3
;
c_IE	EQU	00010010B	;Interrupt Enable
;		x
;		  EX0	: 1=Ext. 0
;		  ET0	: 1=Timer 0
;		  EX1	: 1=Ext. 1
;		  ET1	: 1=Timer 1
;		  ES	: 1=Serial
;		 *ET2	: 1=Timer 2
;		 EA	: 0=disable all, 1=Enable All

iIP	EQU	00000000B	;Interrupt Priority
;		xx
;		   PX0	: 1=Ext. 0
;		   PT0	: 1=Timer 0
;		   PX1	: 1=Ext. 1
;		   PT1	: 1=Timer 1
;		   PS	: 1=Serial
;		  *PT2	: 1=Timer 2

iTMOD	EQU	00100001B	;Timer Mode
;		
;		 MODE0: 00=8048, 01=16bit, 10=auto 8bit, 11=8bit
;		 C/T0	: 0=Timer, 1=Counter
;		 GATE0: 0=run, 1=run if INT0'==1
;		 MODE1: 00=8048, 01=16bit, 10=auto 8bit, 11=stop
;		 C/T1	: 0=Timer, 1=Counter
;		 GATE1: 0=run, 1=run if INT1'==1

iTCON	EQU	01010101B	;Timer Control
;		
;		 IT0	: 0=level, 1=edge
;		 IE0	: Interrupt Edge
;		 IT1	: 0=level, 1=edge
;		 IE1	: Interrupt Edge
;		 TR0	: 0=stop, 1=Run
;		 TF0	: Timer	overflow Flag
;		 TR1	: 0=stop, 1=Run
;		 TF1	: Timer	overflow Flag

c_SCON	EQU	11010000B	;Serial	Control
;		
;		 RI	: Rx Interrupt
;		 TI	: Tx Interrupt
;		 RB8	: 9. receive bit
;		 TB8	: 9. transmit bit
;		 REN	: 1=Rx Enable
;		 SM2	: 1=enable multiprocessor communication
;		 SM01	: 00=fx/12, 01=8bit, 10=9bit fx/32|64, 11=9bit

;*************** PORTs *******************************************************
;******	Port 1	******
IP1	EQU	11111111B	;Init port 1

EEDI	BIT	P1.7		;<-  Data In from EEPROM
EEDO	BIT	P1.7		; -> Data Out to  EEPROM
EECLK	BIT	P1.6		; -> EEPROM clock
EECS	BIT	P1.5		; -> EEPROM chip select
LED_Y	BIT	P1.4		; -> Yellow LED
LED_G	BIT	P1.3		; -> Green LED
LED_R	BIT	P1.2		; -> Red LED
BeepPin	BIT	P1.1		; -> Enable Beep
TMdata	BIT	P1.0		;<-> I/O for driving TM


;******	Port 3 ******
IP3	EQU	11111111B	;Init port 3

Relay	BIT	P3.7		; -> Enable Relay
NU36	BIT	P3.6		; -  not used
NU35	BIT	P3.5		; -  not used
NU34	BIT	P3.4		; -  not used
NU33	BIT	P3.3		; -  not used
TxEn	BIT	P3.2		; -> =0	RS-485 Transmiter Enable
;TxD	BIT	P3.1		; -> TxD
;RxD	BIT	P3.0		;<-  RxD

