	name	EEPROM_driver
;****************************************************************************
;******			       EEPROM DRIVER			       ******
;******				for AT93C66			       ******
;******				word access			       ******
;****************************************************************************

$include(CONST.H)
$include(EEprom.h)

	public	EErd,EEwr,EEwrEn,EEwrDs

EEPROM	segment	code
	rseg	EEPROM
;+--------------------------------------------------------------------------+
;+			Read byte from EEPROM				    +
;+--------------------------------------------------------------------------+
;Input:	 r2 - EEPROM word address
;Output:@r1 - read word	on r1 &	r1+1 address 
;Change:r7,r6,r2,r1,a
EErd:	mov	r6,#OPread	;Request for read
	sjmp	EEEnt

;+--------------------------------------------------------------------------+
;+			 Write byte to EEPROM				    +
;+--------------------------------------------------------------------------+
;Input:@r1 - word to write
;	r2 - EEPROM word address
;Output:word in	EEPROM on r1 & r1+1 address
;Change:r7,r6,r2,r1,a
EEwr:	mov	r6,#OPwrite	;Request for write
	sjmp	EEEnt

;+--------------------------------------------------------------------------+
;+			Enable write command				    +
;+--------------------------------------------------------------------------+
;Input:	-
;Output:Enabled	write to EEPROM
;Change:r7,r6,r2,a
EEwrEn:	mov	r6,#OPserv	;Request for service
	mov	r2,#Enwrite	;Enable	write to EEPROM
	sjmp	EEEnt

;+--------------------------------------------------------------------------+
;+			Disable	write command				    +
;+--------------------------------------------------------------------------+
;Input:	-
;Output:Disabled write to EEPROM
;Change:r7,r6,r2,a
EEwrDs:	mov	r6,#OPserv	;Request for service
	mov	r2,#Dswrite	;Disable write to EEPROM
EEEnt:	setb	EECS		;Select	EEPROM
	setb	EEDI		;Prepare to read
lEEw1:	jnb	EEDI,lEEw1	;wait for EEPROM ready
	clr	EECS
	clr	EEDI
	setb	EECS
	xch	a,r6		;a=OPcode r6=write data
	mov	r7,#3		;tree bits
lEE2:	rlc	a		;
	mov	EEDI,C		;
	clr	EECLK		; write OPcode
	setb	EECLK		;
	djnz	r7,lEE2		;
	rlc	a
	anl	a,#3H		;only 1. and 0.	bit from OPcode
	xch	a,r6		;r6=(OPcode shr	5)and 3	  a =write data
	xch	a,r2		;a =address or command	  r2=write data
	mov	r7,#8		;eight bits of word address
lEE3:	rlc	a		;
	mov	EEDI,C		;
	clr	EECLK		; write address or command
	setb	EECLK		;
	djnz	r7,lEE3		;
	rlc	a
	xch	a,r2		;r2=address a =write data
	xch	a,r6		;a=command  r6=write data
	jz	lEE9		;OPserv->jump
	cjne	a,#01H,lEE5	;Is it read command? yes->jump
	mov	r6,#2		;word=two bytes
lEE41:
	mov	r7,#8H		;all 8 bits
	mov	a,@r1		;a=data	for write
	inc	r1
lEE4:	rlc	a		;
	mov	EEDI,C		;
	clr	EECLK		; write data
	setb	EECLK		;
	djnz	r7,lEE4		;
	djnz	r6,lEE41	;second	byte? yes->jump
	sjmp	lEE9
lEE5:	mov	r6,#2H		;word=two bytes
lEE61:
	mov	r7,#8H		;all 8 bits
	setb	EEDI
lEE6:	clr	EECLK		;
	setb	EECLK		;
	mov	C,EEDO		; read	data
	rlc	a		;
	djnz	r7,lEE6		;
	mov	@r1,a
	inc	r1
	djnz	r6,lEE61	;second	byte ? yes->jump
lEE9:	clr	EECS
	ret
;****************************************************************************
	end
