	name	Access1


;*************** VERSION NUMBER	**********************************************
VERS	EQU	01H		;Version

$include(CONST.H)
$include(EEPROM.H)

	extrn	code	(EErd,EEwr,EEwrEn,EEwrDs)

	extrn	code	(TMtest,TMrd,TMwr,CalcCRC,EntCRC)
	extrn	data	(TMArea,CheckArea,Tries)
	extrn	bit	(TMpre)


	extrn	data	(TicksCounter,RTime,OutTime,RelayTime)
	extrn	data	(Rest,MasterTimeOut)
	extrn	bit	(TimeStamp)
	
	extrn	data	(SerNumH,SerNumL)
	
	extrn	code	(UARTinit,UARTint,SendTempBuf)

	extrn	data	(EE_Address,EE_DataArea)
	extrn	bit	(EE_wrRQ,EE_rdRQ,EE_DrRQ,EE_DwRQ)

	extrn	bit	(InitRq,Ignore,Sec_Op)

	extrn	bit	(BadConfig)

	extrn	data	(iSTACK)

	public		?C_STARTUP,Version

;**********************< M A I N   P R O G R A M >****************************
	USING	0

	CSEG	AT	0000H
?C_STARTUP:
	ajmp	INIT
;----------------------------------------------------------------------------
;	CSEG	AT	0003h	;External 0 interrupt vector
;	ajmp			;NOT USED
;----------------------------------------------------------------------------
	CSEG	AT	000Bh	;Timer 0 interrupt vector - Real Timer generater 
ITim0:
Reload	set	Low(c_Timer0)
  if Reload NE 0
     Reload	set	Low(c_Timer0+4)
	mov	TL0,#Reload
  endif
Reload	set	High(c_Timer0)
  if Reload NE 0
	mov	TH0,#Reload
  endif
	push	psw
	ajmp	ITim0cont
;----------------------------------------------------------------------------
;	CSEG	AT	0013h	;External 1 interrupt vector
;	ajmp	I82C50_service	;NOT USED
;----------------------------------------------------------------------------
;	CSEG	AT	001Bh	;Timer 1 interrupt vector
;	ajmp	ITim1		;NOT USED
;----------------------------------------------------------------------------
	CSEG	AT	0023h	;Serial	port interrupt vector
IntSer:	ajmp	UARTint		;address of interrupt routine

;******	M A I N	  P R O	G R A M	*********************************************

;------<Init system>---------------------------------------------------------
INIT:
	mov	sp,#iSTACK-1
SInit:
	mov	P1,#iP1
	mov	P3,#iP3
	mov	r0,#iSTACK-1		;Clear all internal RAM
SI_0:
	mov	@r0,#0
	djnz	r0,SI_0

	mov	PCON,#iPCON		;
	mov	IP,#iIP			;Set interrupt priority
	mov	TMOD,#iTMOD		;Set timer mode
	mov	TCON,#iTCON		;Set timer control
	mov	SCON,#c_SCON		;Set serial control
	mov	TL0,#Low (c_Timer0)	;Init real time	timer
	mov	TH0,#High(c_Timer0)	;Init real time	timer
	mov	TicksCounter,#c_TicksCounter
	mov	IE,#c_IE		;Set interrupt mask

;------<Init system variables>-----------------------------------------------

	mov	r1,#TMArea		;Where data from EEPROM	will be	moved 
	mov	r2,#EE_ConfigArea	;EEPROM	Config data Area address
	mov	r3,#4			;How many words	to move
NextConfigWord:
	push	ar2			;Save EEPROM config data address
	acall	EErd			;Word move
	pop	ar2			;Restore 
	inc	r2			;Next address
	djnz	r3,NextConfigWord	;Any word to move ? yes->jump
;	 mov	 r5,a			 ;Last read byte to r5
	mov	r0,#TMArea		;
	acall	CalcCRC			;Calculate CRC
	mov	a,TMArea+7
	xrl	a,r5			;Compare readed	& calculated CRC
	jz	ConfigDataCRC_OK	;Are the same ?	yes->jump
	setb	BadConfig		;		no -> Bad configuration	
	mov	TMArea+0,#030		;Standard output configuration
	mov	TMArea+1,#001h		;Standard device address
	mov	TMArea+2,#0FEh		;Standard serial device	number (Hibyte)
	mov	TMArea+3,#0EFh		;Standard serial device	number (Lobyte)
	mov	TMArea+4,#010		;Standard time of result displaying
	mov	TMArea+5,#040		;Standard timeout of MASTERs functions
ConfigDataCRC_OK:
	mov	OutTime,TMArea+0	;Init RAM by configuration data
	mov	a,TMArea+1
	acall	UARTinit		;Initializing serial port
	mov	SerNumL,TMArea+3
	mov	SerNumH,TMArea+2
	mov	Rest,TMArea+4
	mov	MasterTimeOut,TMArea+5
					;End of	Wake Up
	setb	EA			;Enable	interrupts
	
;------<End of system inicialization>----------------------------------------
;------<System is ready	to work	now>-----------------------------------------

	clr	LED_R
	setb	LED_G
NeverEnd:
	acall	WaitForRelease		;Wait for release TM
NeL:
	cpl	LED_R
	cpl	LED_G
	mov	Tries,#3
OnceMore:
	jb	InitRq,INIT
	acall	TMtest
	jb	TMpre,TMpresent
	jnb	TimeStamp,SomeToDo
	acall	OtherWork		;Test on a request from	RS port
	sjmp	NeL
SomeToDo: 
	mov	r7,#0			;Some work should be proccesed there
	djnz	r7,$
	sjmp	OnceMore
TMpresent:
	acall	TMreadROM		;Read ROM ID code of TM
	mov	r0,#TMArea
	acall	CalcCRC			;Calculate CRC
	mov	a,TMArea+7
	clr	LED_G
	setb	LED_R
	xrl	a,r5			;Compare readed	& calculated CRC 
	jz	CRC_OK			;Are both equal? yes->jump
	djnz	Tries,OnceMore		;		 no ->read TM once more	
	ajmp	Error
CRC_OK:
	acall	SearchKEY		;Try search KEY
	jnc	KEYfound
Error:					;Error=KEY didn't found->RED LED is ON
	setb	LED_G
	clr	LED_R
	mov	RTime,Rest
	ajmp	WaitNo
KEYfound:	 
	cjne	r3,#c_TM_Master,NoMASTER;Is it MASTER "KEY" ? no->jump
	clr	LED_R
	setb	LED_G
	clr	BeepPin
	acall	WaitForRelease		;Wait for release TM
	setb	BeepPin
NextClrWait:				;TM was	release
	mov	RTime,MasterTimeOut	;Wait  for next	TM button
ClrWait:
	acall	OtherWork
	acall	TMtest
	jb	TMpre,ClearKEY
	acall	OtherWork
	acall	TMtest
	jb	TMpre,ClearKEY
	acall	OtherWork
	cpl	LED_R
	acall	TMtest
	jb	TMpre,ClearKEY
	mov	a,RTime
	jnz	ClrWait
	ajmp	NeverEnd
ClearKEY:
	mov	Tries,#3
ClearOnceMore:
	acall	TMreadROM		;Read ROM ID code of TM
	mov	r0,#TMArea
	acall	CalcCRC			;Calculate CRC
	mov	a,TMArea+7
	xrl	a,r5			;Compare readed	& calculated CRC
	jz	ClearCRC_OK		;Are both equal? yes->jump
	djnz	Tries,ClearOnceMore	;		 no ->read TM once more
	ajmp	Error
ClearCRC_OK:
	acall	SearchKEY		;Try search KEY
	jnc	ClearKEYfound
	ajmp	ClearNoMASTERwait
ClearKEYfound:				;KEY for clearing found
	cjne	r3,#c_TM_Master,ClearNoMASTER
	ajmp	StartAddKEY
NoMASTER:
	mov	a,OutTime		;"Open door" here
	jz	StartWait
	cjne	a,#c_FlipFlop,NoFlipFlop
	cpl	Relay
	ajmp	StartWait
NoFlipFlop:
	mov	RelayTime,OutTime
StartWait:
	mov	RTime,Rest
WaitYes:
	clr	BeepPin
	acall	OtherWork
	acall	OtherWork
	mov	a,RTime
	jnz	WaitYes
	ajmp	StopBeep
WaitNo:
	acall	OtherWork
	acall	OtherWork
	cpl	BeepPin
	mov	a,RTime
	jnz	WaitNo
StopBeep:
	setb	BeepPin
	mov	r0,#TMArea
	mov	r7,#8
ClearArea:
	mov	@r0,#0
	inc	r0
	djnz	r7,ClearArea
	ajmp	NeverEnd

ClearNoMASTER:
	acall	EEwrEn
	mov	a,r3
	mov	b,#8/2
	mul	ab
	mov	r2,a			;Address of first word of KEY for deleting
	mov	r1,#(CheckArea+1)
	clr	a
	mov	@r1,a
	dec	r1
	mov	@r1,a
	acall	EEwr
	acall	EEwrDs
ClearNoMASTERwait:
	clr	LED_R
	clr	LED_G
	clr	BeepPin
	acall	DoubleWork
	acall	DoubleWork
	setb	BeepPin
	setb	LED_G
	acall	WaitForRelease		;Wait for release TM
	ajmp	NextClrWait
StartAddKEY:
	setb	LED_R
	clr	LED_G
	clr	BeepPin
	acall	WaitForRelease		;Wait for release TM
	setb	BeepPin
NextAddWait:				;MASTER	KEY was	release
	mov	RTime,MasterTimeOut	;Wait  for next	TM button
AddWait:
	acall	OtherWork
	acall	TMtest
	jb	TMpre,AddReadKEY
	acall	OtherWork
	acall	TMtest
	jb	TMpre,AddReadKEY
	acall	OtherWork
	cpl	LED_G
	acall	TMtest
	jb	TMpre,AddReadKEY
	mov	a,RTime
	jnz	AddWait
	ajmp	NeverEnd
AddReadKey:
	mov	Tries,#3
AddOnceMore:
	acall	TMreadROM		;Read ROM ID code of TM
	mov	r0,#TMArea
	acall	CalcCRC			;Calculate CRC
	mov	a,TMArea+7
	xrl	a,r5			;Compare readed	& calculated CRC
	jz	AddCRC_OK		;Are both equal? yes->jump
	djnz	Tries,AddOnceMore	;		 no ->read TM once more
	ajmp	Error
AddCRC_OK:
	acall	SearchKEY		;Try search KEY
	jc	AddStartAdd		;KEY didn't find -> Add	KEY
	cjne	r3,#c_TM_Master,AddWrWait
	ajmp	StartClearAllKEYs
AddStartAdd:	    
	mov	r3,#(c_EE_TM_Start+1)	;Start address of valid	KEYs (first KEY	after MASTER)
NextAddAdr:
	mov	a,r3
	mov	b,#8/2
	mul	ab
	mov	r2,a			;EEPROM	word address
	mov	r1,#CheckArea
	acall	EErd
	mov	a,CheckArea
	orl	a,CheckArea+1
	jz	AddAreaFound
	mov	a,CheckArea
	anl	a,CheckArea+1
	inc	a
	jz	AddAreaFound
	inc	r3
	cjne	r3,#c_EE_TM_Stop,NextAddAdr;
	ajmp	Error			;Area for Add new KEY wasn't find
AddAreaFound:
	acall	EEwrEn
	mov	a,r3			;DALLAS	CODE address
	mov	b,#8/2
	mul	ab
	mov	r2,a			;Start address of EE_Address DALLAS CODE	
	mov	r1,#TMArea		;Address of data to write
	mov	r3,#4			;Four words will be read
AddWrNext:
	push	ar2
	acall	EEwr
	pop	ar2
	inc	r2
	djnz	r3,AddWrNext
AddWrWait:
	acall	EEwrDs
	clr	LED_R
	clr	LED_G
	clr	BeepPin
	acall	DoubleWork
	acall	DoubleWork
	setb	BeepPin
	setb	LED_R
	acall	WaitForRelease		;Wait for release TM
	ajmp	NextAddWait

StartClearAllKEYs:
	clr	LED_R
	setb	LED_G
	clr	BeepPin	
	acall	WaitForRelease		;Wait for release TM
	setb	BeepPin
NextClearWait:				;MASTER	KEY was	release
	mov	RTime,MasterTimeOut	;Wait  for next	TM button
ClearAllWait:
	clr	BeepPin
	acall	OtherWork
	setb	BeepPin
	acall	TMtest
	jb	TMpre,ClearAll
	acall	OtherWork
	acall	TMtest
	jb	TMpre,ClearAll
	acall	OtherWork
	acall	TMtest
	jb	TMpre,ClearAll
	acall	OtherWork
	cpl	LED_R
	cpl	LED_G
	acall	TMtest
	jb	TMpre,ClearAll
	mov	a,RTime
	jnz	ClearAllWait
	ajmp	NeverEnd
ClearAll:
	mov	Tries,#3
ClearAllOnceMore:
	acall	TMreadROM		;Read ROM ID code of TM
	mov	r0,#TMArea
	acall	CalcCRC			;Calculate CRC
	mov	a,TMArea+7
	xrl	a,r5			;Compare readed	& calculated CRC
	jz	ClearAllCRC_OK		;Are both equal? yes->jump
	djnz	Tries,ClearAllOnceMore	;		 no ->read TM once more
ClearAllError:
	ajmp	Error
ClearAllCRC_OK:
	acall	SearchKEY		;Try search KEY
	jc	ClearAllError		;KEY didn't find -> Error
	cjne	r3,#c_TM_Master,ClearAllError
	setb	LED_G
	mov	r3,#c_EE_TM_Start+1	;Start address of valid	KEYs (not MASTER KEY)
	clr	a			;On first address is a MASTER KEY
	mov	CheckArea+0,a
	mov	CheckArea+1,a
	acall	EEwrEn
ClearAllNextAdr:
	mov	a,r3
	mov	b,#8/2
	mul	ab
	mov	r2,a
	mov	r1,#CheckArea
	acall	EEwr
	inc	r3			;Next DALLAS Number
	cpl	LED_R
	cjne	r3,#c_EE_TM_Stop,ClearAllNextAdr;
	clr	LED_R
	clr	LED_G
	clr	BeepPin
	acall	EEwrDs
	acall	DoubleWork
	acall	DoubleWork
	setb	BeepPin
	setb	LED_G
	setb	LED_R
	ajmp	NeverEnd

;------<Subroutines>---------------------------------------------------------

WaitForRelease:
	mov	RTime,#3
ContTestRelease:
	acall	OtherWork
	acall	TMtest
	jb	TMpre,WaitForRelease
	mov	a,RTime
	jnz	ContTestRelease
	ret
	
SearchKEY:
	mov	r3,#c_EE_TM_Start	;Start address of valid	KEYs
NextAdr:				;On first address is a MASTER KEY 
	mov	r0,#TMArea
	mov	a,r3
	mov	b,#8/2
	mul	ab
	mov	r4,a			;Save address for future use
	mov	r5,#4
RepLoop: 
	mov	r2,ar4			;EEPROM	word address
	mov	r1,#CheckArea
	acall	EErd
	mov	a,@r0
	inc	r0
	cjne	a,CheckArea+0,SearchEnd
	mov	a,@r0
	inc	r0
	cjne	a,CheckArea+1,SearchEnd
	inc	r4			;Next word address
	djnz	r5,RepLoop
	clr	C			;Key found
	mov	a,r3
	ret
SearchEnd:
	inc	r3			;Next DALLAS Number
	cjne	r3,#c_EE_TM_Stop,NextAdr;
	setb	C			;Key didn't find
	ret

TMreadROM:
	mov	r1,#TMArea
	mov	a,#33h
	acall	TMwr
	mov	r5,#8
NextByte:
	acall	TMrd
	mov	@r1,a
	inc	r1
	djnz	r5,NextByte
	ret

DoubleWork:
	acall	OtherWork 
OtherWork:
	jbc	EE_wrRQ,WrEEPROM	;Request for EEPROM write & read
	jbc	EE_rdRQ,RdEEPROM	;Request for EEPROM read
	jbc	EE_DrRQ,DrEEPROM	;Request for EEPROM read DALLAS	CODE
	jbc	EE_DwRQ,DwEEPROM	;Request for EEPROM write & read DALLAS	CODE
WaitForTimeStamp:
	clr	TimeStamp
	jnb	TimeStamp,$
	ret
					;EEPROM	service	routine	for RS-485
WrEEPROM:				;Write to EEPROM service routine
	acall	EEwrEn
	mov	r2,EE_Address		;Word address
	mov	r1,EE_DataArea		;Address of data to write
	acall	EEwr
	acall	EEwrDs
RdEEPROM:				;Read from EEPROM service routine
	mov	r2,EE_Address		;Word address
	mov	r1,EE_DataArea		;Address of data to write
	acall	EErd
	mov	a,#6			;Number	of output bytes
	ajmp	StartSendTempBuf
					;EEPROM	service	routine	for RS-485
DwEEPROM:				;Write to EEPROM DALLAS	CODE service routine
	acall	EEwrEn
	mov	a,EE_Address		;DALLAS	CODE address
;	 add	 a,#2			 ;DALLAS 0 -> address=2
	mov	b,#8/2
	mul	ab
	mov	r2,a			;Start address of EE_Address DALLAS CODE	
	mov	r1,EE_DataArea		;Address of data to write
	mov	r3,#4			;Four words will be read
DwNext:
	push	ar2
	acall	EEwr
	pop	ar2
	inc	r2
	djnz	r3,DwNext
	acall	EEwrDs
	mov	r0,EE_DataArea
	mov	@r0,#0Ah
	inc	EE_DataArea
DrEEPROM:				;DALLAS	CODE read service routine
	mov	a,EE_Address		;DALLAS	CODE address
;	 add	 a,#2			 ;DALLAS 0 -> address=2
	mov	b,#8/2
	mul	ab
	mov	r2,a			;Start address of EE_Address DALLAS CODE	
	mov	r1,EE_DataArea		;Address of data to write
	mov	r3,#4			;Four words will be read
DrNext:
	push	ar2
	acall	EErd
	pop	ar2
	inc	r2
	djnz	r3,DrNext
	mov	a,#13			;Number	of output bytes
StartSendTempBuf:
	clr	EA			;Disable all interrupts
	push	psw
	mov	psw,#Bank_1
	mov	r2,a
	call	SendTempBuf
	clr	Ignore			;Init flag - IGNORE STATE
	mov	r4,#0			;Init input chsumm counter
	mov	r5,#0			;Init input char counter
	mov	r6,#2			;Init max input	char
	clr	Sec_op			;Clear secondary opcode	flag (=primary opcode)
	pop	psw
	setb	EA			;Enable	all interrupts
	ajmp	WaitForTimeStamp

;------<Interrupt routines>--------------------------------------------------
ITim0cont:
	push	acc
	setb	TimeStamp
	djnz	TicksCounter,DontElapsed
	mov	TicksCounter,#c_TicksCounter
	mov	a,RelayTime
	jz	NoRelay
	clr	Relay
	djnz	RelayTime,NoRelay
	setb	Relay
NoRelay:
	mov	a,RTime
	jz	DontElapsed
	dec	RTime
DontElapsed:
	pop	acc
	pop	psw
	reti

Texts	SEGMENT	CODE
	RSEG	Texts
Version:
	db	'ACS60 v0.1	 ',0
;			    54321
	end			;This is end of	file


